# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['SqlUserArgs', 'SqlUser']

@pulumi.input_type
class SqlUserArgs:
    def __init__(__self__, *,
                 login_id: pulumi.Input[str],
                 name: pulumi.Input[str],
                 database_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SqlUser resource.
        :param pulumi.Input[str] login_id: SID of SQL login. Can be retrieved using `SqlLogin` or `SELECT SUSER_SID('<login_name>')`.
        :param pulumi.Input[str] name: User name. Cannot be longer than 128 chars.
        :param pulumi.Input[str] database_id: ID of database. Can be retrieved using `Database` or `SELECT DB_ID('<db_name>')`. Defaults to ID of `master`.
        """
        pulumi.set(__self__, "login_id", login_id)
        pulumi.set(__self__, "name", name)
        if database_id is not None:
            pulumi.set(__self__, "database_id", database_id)

    @property
    @pulumi.getter(name="loginId")
    def login_id(self) -> pulumi.Input[str]:
        """
        SID of SQL login. Can be retrieved using `SqlLogin` or `SELECT SUSER_SID('<login_name>')`.
        """
        return pulumi.get(self, "login_id")

    @login_id.setter
    def login_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "login_id", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        User name. Cannot be longer than 128 chars.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="databaseId")
    def database_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of database. Can be retrieved using `Database` or `SELECT DB_ID('<db_name>')`. Defaults to ID of `master`.
        """
        return pulumi.get(self, "database_id")

    @database_id.setter
    def database_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database_id", value)


@pulumi.input_type
class _SqlUserState:
    def __init__(__self__, *,
                 database_id: Optional[pulumi.Input[str]] = None,
                 login_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SqlUser resources.
        :param pulumi.Input[str] database_id: ID of database. Can be retrieved using `Database` or `SELECT DB_ID('<db_name>')`. Defaults to ID of `master`.
        :param pulumi.Input[str] login_id: SID of SQL login. Can be retrieved using `SqlLogin` or `SELECT SUSER_SID('<login_name>')`.
        :param pulumi.Input[str] name: User name. Cannot be longer than 128 chars.
        """
        if database_id is not None:
            pulumi.set(__self__, "database_id", database_id)
        if login_id is not None:
            pulumi.set(__self__, "login_id", login_id)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="databaseId")
    def database_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of database. Can be retrieved using `Database` or `SELECT DB_ID('<db_name>')`. Defaults to ID of `master`.
        """
        return pulumi.get(self, "database_id")

    @database_id.setter
    def database_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database_id", value)

    @property
    @pulumi.getter(name="loginId")
    def login_id(self) -> Optional[pulumi.Input[str]]:
        """
        SID of SQL login. Can be retrieved using `SqlLogin` or `SELECT SUSER_SID('<login_name>')`.
        """
        return pulumi.get(self, "login_id")

    @login_id.setter
    def login_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "login_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        User name. Cannot be longer than 128 chars.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


class SqlUser(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_id: Optional[pulumi.Input[str]] = None,
                 login_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages database-level user, based on SQL login.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_mssql as mssql
        import pulumiverse_mssql as mssql

        example_database = mssql.get_database(name="example")
        example_sql_login = mssql.SqlLogin("exampleSqlLogin",
            name="example",
            password="Str0ngPa$$word12",
            must_change_password=True,
            default_database_id=example_database.id,
            default_language="english",
            check_password_expiration=True,
            check_password_policy=True)
        example_sql_user = mssql.SqlUser("exampleSqlUser",
            name="example",
            database_id=example_database.id,
            login_id=example_sql_login.id)
        pulumi.export("userId", example_sql_user.id)
        ```

        ## Import

        import using <db_id>/<user_id> - can be retrieved using `SELECT CONCAT(DB_ID(), '/', DATABASE_PRINCIPAL_ID('<username>'))`

        ```sh
         $ pulumi import mssql:index/sqlUser:SqlUser example '7/5'
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] database_id: ID of database. Can be retrieved using `Database` or `SELECT DB_ID('<db_name>')`. Defaults to ID of `master`.
        :param pulumi.Input[str] login_id: SID of SQL login. Can be retrieved using `SqlLogin` or `SELECT SUSER_SID('<login_name>')`.
        :param pulumi.Input[str] name: User name. Cannot be longer than 128 chars.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SqlUserArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages database-level user, based on SQL login.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_mssql as mssql
        import pulumiverse_mssql as mssql

        example_database = mssql.get_database(name="example")
        example_sql_login = mssql.SqlLogin("exampleSqlLogin",
            name="example",
            password="Str0ngPa$$word12",
            must_change_password=True,
            default_database_id=example_database.id,
            default_language="english",
            check_password_expiration=True,
            check_password_policy=True)
        example_sql_user = mssql.SqlUser("exampleSqlUser",
            name="example",
            database_id=example_database.id,
            login_id=example_sql_login.id)
        pulumi.export("userId", example_sql_user.id)
        ```

        ## Import

        import using <db_id>/<user_id> - can be retrieved using `SELECT CONCAT(DB_ID(), '/', DATABASE_PRINCIPAL_ID('<username>'))`

        ```sh
         $ pulumi import mssql:index/sqlUser:SqlUser example '7/5'
        ```

        :param str resource_name: The name of the resource.
        :param SqlUserArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SqlUserArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_id: Optional[pulumi.Input[str]] = None,
                 login_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SqlUserArgs.__new__(SqlUserArgs)

            __props__.__dict__["database_id"] = database_id
            if login_id is None and not opts.urn:
                raise TypeError("Missing required property 'login_id'")
            __props__.__dict__["login_id"] = login_id
            if name is None and not opts.urn:
                raise TypeError("Missing required property 'name'")
            __props__.__dict__["name"] = name
        super(SqlUser, __self__).__init__(
            'mssql:index/sqlUser:SqlUser',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            database_id: Optional[pulumi.Input[str]] = None,
            login_id: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'SqlUser':
        """
        Get an existing SqlUser resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] database_id: ID of database. Can be retrieved using `Database` or `SELECT DB_ID('<db_name>')`. Defaults to ID of `master`.
        :param pulumi.Input[str] login_id: SID of SQL login. Can be retrieved using `SqlLogin` or `SELECT SUSER_SID('<login_name>')`.
        :param pulumi.Input[str] name: User name. Cannot be longer than 128 chars.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SqlUserState.__new__(_SqlUserState)

        __props__.__dict__["database_id"] = database_id
        __props__.__dict__["login_id"] = login_id
        __props__.__dict__["name"] = name
        return SqlUser(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="databaseId")
    def database_id(self) -> pulumi.Output[str]:
        """
        ID of database. Can be retrieved using `Database` or `SELECT DB_ID('<db_name>')`. Defaults to ID of `master`.
        """
        return pulumi.get(self, "database_id")

    @property
    @pulumi.getter(name="loginId")
    def login_id(self) -> pulumi.Output[str]:
        """
        SID of SQL login. Can be retrieved using `SqlLogin` or `SELECT SUSER_SID('<login_name>')`.
        """
        return pulumi.get(self, "login_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        User name. Cannot be longer than 128 chars.
        """
        return pulumi.get(self, "name")

